package com.ixee.GraphIX;

import com.ixee.datastruct.Coordinate;
import com.ixee.io.stdio;

public class GIXMath{
	float[] rootTable;//one day set this up to contain a table of precomputed square roots. Probably 1.0-50.0k or so. That's 4mb.
	float[][] trigtable; //a table of sin/cos for 0 to 360, 0.001 degree intervals. That makes for 360000*2 entries or roughly 5.76mb
	int trigPrecision = 1000; //number of entries between two given degrees.
	boolean init = false;

	static float temp;
	static int index;

	public GIXMath(){
		initTrig();
		initRoot();
		init=true;
	}
	private void initTrig(){
//		stdio.println("Initializing GIXMath trig table");
//		stdio.println("Sin and cos for 0 to 360, precision of "+trigPrecision);
		int percentageGoal = 0;
		int percentageDetail = 5;
		int percentage = 0;
		trigtable = new float[360*trigPrecision][2];
		for(int i=0;i<360*trigPrecision;i++){
			trigtable[i][0] = (float)Math.sin(Math.toRadians(((float)i)/trigPrecision));
			trigtable[i][1] = (float)Math.cos(Math.toRadians(((float)i)/trigPrecision));
			percentage = (int)(i*100.0/(360*trigPrecision));
			//System.out.println(i +" -> "+trigtable[i][0]);
			if((int)Math.round(percentage)==percentageGoal){
//				stdio.println(percentage+"% completed");
				percentageGoal += percentageDetail;
			}
		}
		stdio.println("Trig table generated.");
	}
	private void initRoot(){
	}
	public float cos(float d){
		temp = reduceAngle((float)Math.toDegrees(d));
		index = (int)Math.round(temp*trigPrecision)%trigtable.length;
		return trigtable[index][1];
	}
	public float sin(float d){
		temp = reduceAngle((float)Math.toDegrees(d));
		index = (int)Math.round(temp*trigPrecision)%trigtable.length;
		return trigtable[index][0];
	}
	public float reduceAngle(float d){
		while(d>=360){
			d-=360;
		}
		while(d<0){
			d+=360;
		}
		return d;
	}
	public float toRadians(float angle){
		return angle*3.14159265358f/180;
	}
	public static Coordinate toScreenSpace(Coordinate gameSpace, Coordinate cameraLoc){

		Coordinate correction = cameraLoc;
		double scaleFactor = 1/cameraLoc.getZ();
		Coordinate temp = new Coordinate(correction);
		temp = gameSpace.sub(temp);
		temp = new Coordinate(temp.getX()*scaleFactor, temp.getY()*scaleFactor, temp.getZ());

		return temp;
	}
}