package com.ixee.datastruct;

public class ArrayPile<E>{
	E[] contents;
	int mostRecentIndex = 0;

	public ArrayPile(int size){
		contents = (E[])new Object[size];
		for(int i=0;i<contents.length;i++){
			contents[i] = null;
		}
	}

    public E get(int index) {
		int internalIndex = mostRecentIndex + index;
		if(internalIndex >= contents.length){
			internalIndex -= contents.length;
		}
		return contents[internalIndex];
    }
    public void add(E e){
		contents[mostRecentIndex] = e;
		mostRecentIndex++;
		if(mostRecentIndex>=contents.length){
			mostRecentIndex = 0;
		}
	}
	public int size(){
		return contents.length;
	}
}