package com.ixee.datastruct;

public class Coordinate_m extends Coordinate{
	int ops = 0;
	static final int OP_THRESHOLD = 16384;

	public static void main(String[] args){
		Coordinate c = new Coordinate_m(5, -5, 3);

		long start;

		start = System.nanoTime();

		for(int i=0;i<10000000;i++){
			c.mult_p(1.0/7000.0);

			c.add_p(1.0, 2.0, 3.5);

			c.mult_p(2);
			c.mult_p(1/3.0);


			c.mult_p(3.0);
			c.mult_p(1.0/2.0);

			c.sub_p(1.0, 2.0, 3.5);

			c.mult_p(7000);

		}
		System.out.println("Done in " + (System.nanoTime()-start)/1000000 + "ms");


		start = System.nanoTime();

		for(int i=0;i<10000000;i++){
			c = c.mult(1.0/7000.0);

			c = c.add(1.0, 2.0, 3.5);

			c = c.mult(2);
			c = c.mult(1/3.0);


			c = c.mult(3.0);
			c = c.mult(1.0/2.0);

			c = c.sub(1.0, 2.0, 3.5);

			c = c.mult(7000);

		}
		System.out.println("Done in " + (System.nanoTime()-start)/1000000 + "ms");

		System.out.println(c);

	}

	public Coordinate_m(double x, double y){
		super(x, y);
	}
	public Coordinate_m(double x, double y, double z){
		super(x, y, z);
	}
	public Coordinate_m(Coordinate c){
		super(c);
	}
	public Coordinate_m(double x, double y, double z, int i){
		super(x, y, z);
		ops = i;
		if(ops >= OP_THRESHOLD){
			round();
		}
	}
	public Coordinate_m(Coordinate c, int i){
		super(c);
		ops = i;
		if(ops >= OP_THRESHOLD){
			round();
		}
	}
	private void round(){
		px = Math.round(px*100000)/100000.0;
		py = Math.round(py*100000)/100000.0;
		pz = Math.round(pz*100000)/100000.0;
		ops = 0;
	}
	public Coordinate add_p(Coordinate c){
		px += c.getX();
		py += c.getY();
		pz += c.getZ();
		ops++;
		return this;
	}
	public Coordinate add_p(double x, double y){
		px += x;
		py += y;
		ops++;
		return this;
	}
	public Coordinate add_p(double x, double y, double z){
		px += x;
		py += y;
		pz += z;
		ops++;
		return this;
	}
	public Coordinate sub_p(Coordinate c){
		px -= c.getX();
		py -= c.getY();
		pz -= c.getZ();
		ops++;
		return this;
	}
	public Coordinate sub_p(double x, double y){
		px -= x;
		py -= y;
		ops++;
		return this;
	}
	public Coordinate sub_p(double x, double y, double z){
		px -= x;
		py -= y;
		pz -= z;
		ops++;
		return this;
	}
	public Coordinate mult_p(double d){
		px *= d;
		py *= d;
		pz *= d;
		ops++;
		return this;
	}
	public Coordinate add(Coordinate c){
		return new Coordinate_m(this, ops).add_p(c);
	}
	public Coordinate add(double x, double y, double z){
		return new Coordinate_m(this, ops).add_p(x, y, z);
	}
	public Coordinate add(double x, double y){
		return new Coordinate_m(this, ops).add_p(x, y);
	}
	public Coordinate sub(Coordinate c){
		return new Coordinate_m(this, ops).sub_p(c);
	}
	public Coordinate sub(double x, double y, double z){
		return new Coordinate_m(this, ops).sub_p(x, y, z);
	}
	public Coordinate sub(double x, double y){
		return new Coordinate_m(this, ops).sub_p(x, y);
	}
	public Coordinate mult(double d){
		return new Coordinate_m(this, ops).mult_p(d);
	}
}