//TODO: Make it so things can't be reconnected to one another multiple times.

package com.ixee.datastruct;

import com.ixee.io.stdio;
import com.ixee.datastruct.GraphNode;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Iterator;
import java.util.ListIterator;

public class Graph<T>{
	HashMap<T, GraphNode<T>> nodeMap;
	HashMap<T, ArrayList<GraphNodeConnection<T>>> nodeConnectionMap;
	LinkedList<GraphNode<T>> nodes;

	public Graph(){
		nodes = new LinkedList<GraphNode<T>>();
		nodeMap = new HashMap<T, GraphNode<T>>();
		nodeConnectionMap = new HashMap<T, ArrayList<GraphNodeConnection<T>>>();
	}
	public int numNodes(){
		return nodes.size();
	}
	public ArrayList<ArrayList<T>> getConnections(){
		/*
			This is a very poor and slow way of doing things please never do this again.


		*/
		HashMap<T, ArrayList<GraphNodeConnection<T>>> paredDownList = new HashMap<T, ArrayList<GraphNodeConnection<T>>>();

		ListIterator<GraphNode<T>> iter = nodes.listIterator(0);

		GraphNode<T> currNode;

		int connections = 0;

		while(iter.hasNext() && (currNode = iter.next()) != null){
			ArrayList<GraphNodeConnection<T>> currConnections = nodeConnectionMap.get(currNode.getContents());
			for(int i=0;i<currConnections.size();i++){
				boolean canAdd = true;
				if(paredDownList.get(currConnections.get(i).getObj().getContents()) == null){
					canAdd = true;
				}else{
					ArrayList<GraphNodeConnection<T>> objConnections = paredDownList.get(currConnections.get(i).getObj().getContents());
					for(int j=0;j<objConnections.size();j++){
						if(currNode == objConnections.get(j).getObj()){
							canAdd = false;
						}
					}
				}
				if(canAdd){
					if(paredDownList.get(currNode.getContents()) == null){
						paredDownList.put(currNode.getContents(), new ArrayList<GraphNodeConnection<T>>());
					}
					paredDownList.get(currNode.getContents()).add(currConnections.get(i));
					connections++;
				}
			}
		}
		ArrayList<ArrayList<T>> returnable = new ArrayList<ArrayList<T>>(connections);

		int count = 0;

		Iterator<T> start = paredDownList.keySet().iterator();

		for(int i=0;start.hasNext() != false;i++){
			//returnable[count][0] = start[i];
			T current = start.next();
			ArrayList<GraphNodeConnection<T>> startConn = paredDownList.get(current);
			for(int j=0;j<startConn.size();j++){
				returnable.add(new ArrayList<T>());
				returnable.get(count).add(current);
				returnable.get(count).add(startConn.get(j).getObj().getContents());
				count++;
			}
		}
		return returnable;
	}
	public ArrayList<T> path(T source, T dest){
		/*
			The way this is set up, it does not handle non-1 lengths between nodes!!
			Definitely fix that!
		*/
		GraphNode<T> sourceNode = nodeMap.get(source);
		GraphNode<T> destNode = nodeMap.get(dest);
		ArrayList<T> returnable;
		GraphNode<T> tempTree;
		LinkedList<GraphNode<T>> nodesToExplore = new LinkedList<GraphNode<T>>();
		if(sourceNode == null || destNode == null){
			returnable = null;
		}else{
			boolean iterationComplete = false;
			returnable = new ArrayList<T>();
			ArrayList<T> finalList = new ArrayList<T>();
			ListIterator<GraphNode<T>> fullNodeIterator = nodes.listIterator();
			while(fullNodeIterator.hasNext()){				//Resetting all the nodes to a non-explored status.
				fullNodeIterator.next().setExplored(false);
			}
			GraphNode<T> current = sourceNode;	//The node currently under investigation.
			//current.setExplored(true);
			nodesToExplore.add(current);
			tempTree = sourceNode;

			//The first condition here will currently NEVER be met. This seems to be a good thing as the
			//algorithm current terminates as soon as it notices the destination node is found,
			//rather than when it processes all other nodes in the queue before it.

			while(nodesToExplore.size() != 0 && nodesToExplore.getFirst() != dest &&!iterationComplete){
				current = nodesToExplore.removeFirst();
				//System.out.println(current.getContents());
				ArrayList<GraphNodeConnection<T>> nodeConnections = nodeConnectionMap.get(current.getContents());
				//nodeConnections should literally NEVER be null, because every GraphNode added has an ArrayList<GraphNodeConnection> made for it.
				//If it is null, something rather major went wrong.
				for(int i=0;i<nodeConnections.size() && !iterationComplete;i++){
					if(!nodeConnections.get(i).getObj().isExplored()){
						if(nodeConnections.get(i).getObj().getContents() == dest){
							iterationComplete = true;
							//System.out.println("Graph: Path complete!");
							finalList.add(nodeConnections.get(i).getObj().getContents());
							ArrayList<T> toAdd = path(source, current.getContents());
							for(int j=0;j<toAdd.size();j++){
								finalList.add(toAdd.get(j));
							//	System.out.println("Adding "+toAdd.get(j));
							}
						}else{
							nodesToExplore.add(nodeConnections.get(i).getObj());
						}
					}
				}
				current.setExplored(true);
			}
			returnable = finalList;
		}
		return returnable;
	}
	public GraphNode<T> getNodeFor(T n){
		return nodeMap.get(n);
	}
	public void createNode(T n){
		GraphNode<T> addable = new GraphNode<T>(n);
		nodes.add(addable);
		nodeMap.put(n, addable);
		nodeConnectionMap.put(n, new ArrayList<GraphNodeConnection<T>>());
	}
	public void connectNodes(T n, ArrayList<T> toConnect, ArrayList<Double> dists){
		GraphNode<T> addable = nodeMap.get(n);
		//nodes.add(addable);
		//nodeMap.put(n, addable);
		for(int i=0;i<toConnect.size();i++){
			GraphNode<T> connectableNode = nodeMap.get(toConnect.get(i));
			if(connectableNode != null){
				connect(n, toConnect.get(i), dists.get(i));
			}else{
				stdio.debugAndLog(this, "Tried to connect a node to a node that was never defined! That seems problematic!!");
			}
		}
	}
	public void disconnect(T s, T d){
		GraphNode<T> source = nodeMap.get(s);
		GraphNode<T> dest = nodeMap.get(d);
		if(source != null && dest != null){
			ArrayList<GraphNodeConnection<T>> sourceConnections = nodeConnectionMap.get(s);
			ArrayList<GraphNodeConnection<T>> destConnections = nodeConnectionMap.get(d);
			for(int i=0;i<sourceConnections.size();i++){
				if(sourceConnections.get(i).getObj() == dest){
					sourceConnections.remove(sourceConnections.get(i));
				}
			}
			for(int i=0;i<destConnections.size();i++){
				if(destConnections.get(i).getObj() == source){
					destConnections.remove(destConnections.get(i));
				}
			}
		}
	}
	public void connect(T s, T d, double dist){
		GraphNode<T> source = nodeMap.get(s);
		GraphNode<T> dest = nodeMap.get(d);
		if(source != null && dest != null){
			//Neither of the following should ever be null. If they are something major went wrong.
			ArrayList<GraphNodeConnection<T>> sourceConnections = nodeConnectionMap.get(s);
			ArrayList<GraphNodeConnection<T>> destConnections = nodeConnectionMap.get(d);
			sourceConnections.add(new GraphNodeConnection<T>(dest, dist));
			destConnections.add(new GraphNodeConnection<T>(source, dist));
		}else{
			stdio.debugAndLog(this, "Tried to connect a node to a node that was never defined! That seems problematic!!");
		}
	}
	public boolean connected(T a, T b){
		boolean returnable = false;
		GraphNode<T> aNode = nodeMap.get(a);
		GraphNode<T> bNode = nodeMap.get(b);
		if(aNode != null && bNode != null){
			ArrayList<GraphNodeConnection<T>> connections = nodeConnectionMap.get(a);
			for(int i=0;i<connections.size();i++){
				if(connections.get(i).getObj() == bNode){
					returnable = true;
				}
			}
		}
		return returnable;
	}
	public boolean contains(T a){
		boolean returnable = false;
		if(nodeMap.get(a) != null){
			returnable = true;
		}
		return returnable;
	}
}