package com.ixee.datastruct;

import java.util.Iterator;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.HashMap;

class RangeList<T>{
	LinkedList<RangeListElement<T>> elements;
	HashMap<T, RangeListElement<T>[]> elementMap;

	public RangeList(){
		elements = new LinkedList<RangeListElement<T>>();
		elementMap = new HashMap<T, RangeListElement<T>[]>();
	}
	public ArrayList<T> rangesAt(double x){
		ArrayList<T> returnable = new ArrayList<T>();
		HashMap<T, RangeListElement<T>> addedElem = new HashMap<T, RangeListElement<T>>();
		ListIterator<RangeListElement<T>> li = elements.listIterator(0);
		RangeListElement<T> current;
		boolean done = false;

		while(li.hasNext() && done == false){
			current = li.next();
			if(current.position() < x){
				if(addedElem.get(current.elem()) == null){
					addedElem.put(current.elem(), current);
				}else{
					addedElem.remove(current.elem());
				}
			}else{
				done = true;
			}
		}
		Iterator<T> keyIterator = addedElem.keySet().iterator();
		while(keyIterator.hasNext()){
			returnable.add(keyIterator.next());
		}
		return returnable;
	}
	public boolean remove(T t){
		boolean removable = false;
		if(elementMap.get(t) != null){
			removable = true;
			elementMap.remove(t);
		}
		return removable;
	}
	//This does not allow the same element to be added more than once!
	public void add(T t, double start, double range){
		if(range < 0){
			throw new IllegalArgumentException("Range given was negative. RangeList requires positive values for ranges.");
		}
		if(elementMap.get(t) == null){
			RangeListElement[] elementsToAdd = {new RangeListElement<T>(t, start), new RangeListElement<T>(t, start+range)};
			elementMap.put(t, elementsToAdd);
			ListIterator<RangeListElement<T>> lli = elements.listIterator(0);
			int elemToPlace = 0;
			//place the first element in our list, sorting it into the proper place.

			RangeListElement current = null;
			while(lli.hasNext() && elemToPlace<2){
				current = lli.next();
				if(current.position() < elementsToAdd[elemToPlace].position()){
					lli.add(elementsToAdd[elemToPlace]);
					elemToPlace++;
				}
			}
			if(elemToPlace < 2){
				elements.add(elementsToAdd[elemToPlace]);
				elemToPlace++;
			}
		}
	}
}

class RangeListElement<T>{
	T elem;
	double position;
	public RangeListElement(T t, double p){
		elem = t;
		position = p;
	}
	public double position(){
		return position;
	}
	public T elem(){
		return elem;
	}
}