package com.ixee.ui;

public class MenuStack{
	Menu[][] menuStack;

	public MenuStack(){
		menuStack = new Menu[1][0];
	}
	public int getDepth(){
		return menuStack.length;
	}
	public void addMenu(Menu m){
		//System.out.println(m + " is a top? "+m.topMenu());
		if(m.topMenu()){
			pushMenus();
		}
		add(m);
	}
	private void pushMenus(){
		Menu[][] menuStack2 = new Menu[menuStack.length + 1][];
		System.arraycopy(menuStack, 0, menuStack2, 1, menuStack.length);
		menuStack2[0] = new Menu[0];
		menuStack = menuStack2;

	}
	private void add(Menu m){
		Menu[] derp;
		//if(menuStack[0] == null){
		//	derp = new Menu[1];
		//	derp[0] = m;
		//}else{
		derp = new Menu[menuStack[0].length+1];
		System.arraycopy(menuStack[0], 0, derp, 1, menuStack[0].length);
		derp[0]=m;
		//}
		menuStack[0] = derp;
	}
	public Menu getMenu(){
		return menuStack[0][0];
	}
	public void removeMenu(Menu m){
		for(int i=0;i<menuStack.length;i++){
			for(int j=0;j<menuStack[i].length;j++){
				//it crashes because menuStack[0] is an array of size 0.
				if(menuStack[i][j] == m){
					remove(i, j);
				}
			}
		}
	}
	private void popMenus(){
		Menu[][] menuStack2 = new Menu[menuStack.length-1][];
		System.arraycopy(menuStack, 1, menuStack2, 0, menuStack2.length);
		menuStack = menuStack2;
	}
	public Menu[] getTopMenus(){
		return menuStack[0];
	}
	private void remove(int i, int j){
		//System.out.println("Removing menu "+menuStack[i][j]+" at "+i+", "+j);
		//i is the index of the Menu[] in which the Menu we're removing resides. j is the index of the menu to remove.
		Menu[] replacement = new Menu[menuStack[i].length-1];
		if(replacement.length != 0){
			Menu[] original = menuStack[i];
			System.arraycopy(original, 0, replacement, 0, j);
			System.arraycopy(original, j+1, replacement, j, replacement.length-j);
			menuStack[i] = replacement;
		}else{
			popMenus();
		}
	}
	public void draw(){
	}
	public void check(){
	}
	public String toString(){
		String returnable = "";
		for(int i=0;i<menuStack.length;i++){
			for(int j=0;j<menuStack[i].length;j++){
				returnable = returnable.concat(menuStack[i][j] + "@ "+i+" "+j+"\n\r");
			}
		}
		return returnable;
	}
}