/*
	This just extends UIActiveElement for OpenGL. Doesn't do anything new, itself.
*/
package com.ixee.ui.ogl;

import com.ixee.datastruct.Coordinate;
import com.ixee.ui.CursorInfo;

public abstract class UIActiveElement extends UIElement{
	protected int boundMode = -1;
	protected boolean toggleActiveMode;
	protected boolean active;
	protected boolean focused;

	public UIActiveElement(Coordinate position){
		super(position);
		toggleActiveMode = false;
		active = false;
		//the exact constructors for active elements are defined in their classes
	}
	public UIActiveElement(Coordinate position, int mode){
		super(position);
		toggleActiveMode = false;
		active = false;
		bindMode(mode);
	}
	public void bindMode(int i){
		boundMode = i;
	}
	public int getMode(){
		if(active){
			active = false;
			return boundMode;
		}else{
			return -1;
		}
	}
	public boolean isActive(){
		return active;
	}
	protected void makeActive(){
		if(toggleActiveMode){
		//	System.out.println("Making "+this + " active!");
			active = true;
			toggleActiveMode = false;
		}
	}
	public void setFocused(boolean b){
		focused = b;
	}
	public abstract void testForActive(CursorInfo inf);
		//this is also on a per-active-element basis. Tests some input to see if this is active
	public abstract void setAppearance();
		//this lets us decide how the active element appears by default.
	public abstract void setActiveAppearance();
		//this lets us describe how the element will appear when it is the active one
}