package com.ixee.ui.ogl;

import com.ixee.GraphIX.glEEngine;
import com.ixee.datastruct.Coordinate;
import java.awt.Color;

public class UIRect extends UIPoly{

	public UIRect(Coordinate cent, Coordinate[] vert, Color c){
		super(cent, new Coordinate[]{}, c);
		vertices = new Coordinate[4];
		setCoords(vert);
	}
	public void setCoords(Coordinate[] newVert){
		if(newVert.length<4){
			return;
		}else{
			maxRight = 0;
			maxLeft = 0;
			maxTop = 0;
			maxBottom = 0;
			for(int i=0;i<4;i++){
				maxRight = Math.max(maxRight, newVert[i].getX());
				maxLeft = Math.min(maxLeft, newVert[i].getX());
				maxTop = Math.max(maxTop, newVert[i].getY());
				maxBottom = Math.min(maxBottom, newVert[i].getY());
				vertices[i] = newVert[i].add(centerpoint);
			}
		}
	}
	public void draw(glEEngine e){
		if(!fill){
			e.drawRect(vertices, drawCol);
		}else{
			e.fillRect(vertices, drawCol);
		}
	}
	public double right(){
		return centerpoint.getX()+maxRight;
	}
	public double left(){
		return centerpoint.getX()+maxLeft;
	}
	public double top(){
		return centerpoint.getY()+maxTop;
	}
	public double bottom(){
		return centerpoint.getY()+maxBottom;
	}
}